use kernel::prelude::*;

module! {
    type: RustOutOfTree,
    name: "test_module",
    author: "Florian RICHER <florian.richer@protonmail.com>",
    description: "Un module noyau qui affiche un message",
    license: "GPL",
}

struct RustOutOfTree;

impl kernel::Module for RustOutOfTree {
    fn init(_module: &'static ThisModule) -> Result<Self> {
        pr_info!("Bonjour! Le module est chargé.\n");

        Ok(RustOutOfTree)
    }
}

impl Drop for RustOutOfTree {
    fn drop(&mut self) {
        pr_info!("Au revoir! Le module est déchargé.\n");
    }
}
